49
\$\begingroup\$

Given an array a that contains only numbers in the range from 1 to a.length, find the first duplicate number for which the second occurrence has the minimal index. In other words, if there are more than 1 duplicated numbers, return the number for which the second occurrence has a smaller index than the second occurrence of the other number does. If there are no such elements, your program / function may result in undefined behaviour.

Example:

For a = [2, 3, 3, 1, 5, 2], the output should be firstDuplicate(a) = 3.

There are 2 duplicates: numbers 2 and 3. The second occurrence of 3 has a smaller index than the second occurrence of 2 does, so the answer is 3.

For a = [2, 4, 3, 5, 1], the output should be firstDuplicate(a) = -1.

This is , so shortest answer in bytes wins.

BONUS: Can you solve it in O(n) time complexity and O(1) additional space complexity?

\$\endgroup\$
1
  • \$\begingroup\$ Comments are not for extended discussion; this conversation has been moved to chat. \$\endgroup\$ Sep 3, 2017 at 13:12

67 Answers 67

17
\$\begingroup\$

Python 2, 34 bytes

O(n2) time, O(n) space

Saved 3 bytes thanks to @vaultah, and 3 more from @xnor!

lambda l:l[map(l.remove,set(l))<0]

Try it online!

\$\endgroup\$
7
  • 1
    \$\begingroup\$ It looks like lambda l:l[map(l.remove,set(l))<0] works, even though the order of evaluation is weird. \$\endgroup\$
    – xnor
    Jul 31, 2017 at 0:08
  • \$\begingroup\$ This doesn't return -1 when no duplicates are found without the 'footer code', does that code not count towards the bytes? I'm new to code golf, sorry if it's a basic question! \$\endgroup\$ Jul 31, 2017 at 12:38
  • \$\begingroup\$ @Chris_Rands Beneath the question musicman did ask if exception is okay instead of -1 and OP said its okay and musicman's answer throws exception. \$\endgroup\$
    – LiefdeWen
    Jul 31, 2017 at 13:55
  • \$\begingroup\$ That took me a while to figure out. Well played. Getting the 0th element of l using the conditional after modifying it is really clever. \$\endgroup\$
    – Thoth19
    Jul 31, 2017 at 22:45
  • \$\begingroup\$ Does Python guarantee the time and space complexity of standard-library functions like set.remove? \$\endgroup\$
    – Draconis
    Aug 1, 2017 at 2:30
15
\$\begingroup\$

JavaScript (ES6), 47 36 31 25 bytes

Saved 6 bytes thanks to ThePirateBay

Returns undefined if no solution exists.

Time complexity: O(n) :-)
Space complexity: O(n) :-(

a=>a.find(c=>!(a[-c]^=1))

How?

We keep track of already encountered values by saving them as new properties of the original array a by using negative numbers. This way, they can't possibly interfere with the original entries.

Demo

let f =

a=>a.find(c=>!(a[-c]^=1))

console.log(f([2, 3, 3, 1, 5, 2]))
console.log(f([2, 4, 3, 5, 1]))
console.log(f([1, 2, 3, 4, 1]))

\$\endgroup\$
3
  • \$\begingroup\$ 25 bytes: a=>a.find(c=>!(a[-c]^=1)) \$\endgroup\$
    – user72349
    Jul 30, 2017 at 22:11
  • \$\begingroup\$ @ThePirateBay Oh, of course. Thanks! \$\endgroup\$
    – Arnauld
    Jul 30, 2017 at 22:14
  • \$\begingroup\$ Just notice that Objects in JavaScript may not be implemented as hash table. Time complexity of accessing keys of some object may not be O(1). \$\endgroup\$
    – tsh
    Aug 1, 2017 at 9:47
6
\$\begingroup\$

Mathematica, 24 bytes

#/.{h=___,a_,h,a_,h}:>a&

Mathematica's pattern matching capability is so cool!

Returns the original List for invalid input.

Explanation

#/.

In the input, replace...

{h=___,a_,h,a_,h}

A List with a duplicate element, with 0 or more elements before, between, and after the duplicates...

... :>a

With the duplicate element.

\$\endgroup\$
6
\$\begingroup\$

Jelly, 5 bytes

Ṛœ-QṪ

Try it online!

How it works

Ṛœ-QṪ  Main link. Argument: A (array)

Ṛ      Yield A, reversed.
   Q   Unique; yield A, deduplicated.
 œ-    Perform multiset subtraction.
       This removes the rightmost occurrence of each unique element from reversed
       A, which corresponds to the leftmost occurrence in A.
    Ṫ  Take; take the rightmost remaining element, i.e., the first duplicate of A.
\$\endgroup\$
2
  • \$\begingroup\$ œ- removes the rightmost occurrences? TIL \$\endgroup\$ Jul 31, 2017 at 9:42
  • \$\begingroup\$ This doesn't seem to return -1 for no duplicates. Throwing an exception is okay as per OP but I'm not sure if 0 is even though it's not in the range. \$\endgroup\$ Jul 31, 2017 at 12:18
5
\$\begingroup\$

Pyth, 5 bytes

h.-Q{

Test suite

Remove from Q the first appearance of every element in Q, then return the first element.

\$\endgroup\$
2
  • \$\begingroup\$ @LuisMendo Ok thanks. Sorry for creating confusion, I should learn to read... \$\endgroup\$
    – Mr. Xcoder
    Jul 31, 2017 at 11:53
  • \$\begingroup\$ @Mr.Xcoder No, it's the OP's fault. That information should be in the challenge text, but just in a comment \$\endgroup\$
    – Luis Mendo
    Jul 31, 2017 at 12:40
5
\$\begingroup\$

Haskell, 35 bytes

f s(h:t)|h`elem`s=h|1<2=f(h:s)t
f[]

Try it online! Crashes if no duplicate is found.

\$\endgroup\$
5
+100
\$\begingroup\$

Vyxal, 4 bytes

UÞ⊍h

Try it Online!

Takes the multi-set symmetric difference, which outputs the duplicate values in order that they occur. Outputs 0 if nothing is found.

\$\endgroup\$
4
\$\begingroup\$

Jelly, 6 bytes

xŒQ¬$Ḣ

Try it online!

Returns the first duplicate, or 0 if there is no duplicate.

Explanation

xŒQ¬$Ḣ  Input: array M
    $   Operate on M
 ŒQ       Distinct sieve - Returns a boolean mask where an index is truthy
          for the first occurrence of an element
   ¬      Logical NOT
x       Copy each value in M that many times
     Ḣ  Head
\$\endgroup\$
2
  • \$\begingroup\$ It's golfier to use indexing like this: ŒQi0ị. \$\endgroup\$ Jul 31, 2017 at 12:23
  • \$\begingroup\$ @EriktheOutgolfer If there are no duplicates, i0 would return 0, where would index and return the last value of the input instead of 0. \$\endgroup\$
    – miles
    Jul 31, 2017 at 12:31
4
\$\begingroup\$

Japt, 7 bytes

æ@bX ¦Y

Test it online!

Explanation

 æ@   bX ¦ Y
UæXY{UbX !=Y}  Ungolfed
               Implicit: U = input array
UæXY{       }  Return the first item X (at index Y) in U where
     UbX         the first index of X in U
         !=Y     is not equal to Y.
               In other words, find the first item which has already occured.
               Implicit: output result of last expression

Alternatively:

æ@¯Y øX

Test it online!

Explanation

 æ@   ¯ Y øX
UæXY{Us0Y øX}  Ungolfed
               Implicit: U = input array
UæXY{       }  Return the first item X (at index Y) in U where
     Us0Y        the first Y items of U (literally U.slice(0, Y))
          øX     contains X.
               In other words, find the first item which has already occured.
               Implicit: output result of last expression
\$\endgroup\$
4
\$\begingroup\$

Dyalog APL, 27 24 20 19 13 12 11 bytes

⊢⊃⍨0⍳⍨⊢=⍴↑∪

Now modified to not depend on v16! Try it online!

How? (With input N)

  • ⊢⊃⍨... - N at this index:
    • ⍴↑∪ - N with duplicates removed, right-padded with 0 to fit N
    • ⊢= - Element-wise equality with N
    • 0⍳⍨ - Index of the first 0. `
\$\endgroup\$
10
  • \$\begingroup\$ nevermind, I misread the question. not enough test cases though... \$\endgroup\$
    – Uriel
    Jul 30, 2017 at 21:44
  • \$\begingroup\$ Sorry for misleading you, I also misread the question. \$\endgroup\$
    – miles
    Jul 30, 2017 at 22:12
  • \$\begingroup\$ Looks like 36 bytes to me. \$\endgroup\$
    – Adám
    Jul 31, 2017 at 11:09
  • \$\begingroup\$ Oh god, iota underbar isn't in ⎕AV, is it? \$\endgroup\$
    – Adalynn
    Jul 31, 2017 at 11:22
  • \$\begingroup\$ @Zacharý Right, Classic translates it to ⎕U2378  when loading. Try it online! \$\endgroup\$
    – Adám
    Aug 4, 2017 at 4:44
4
\$\begingroup\$

Brachylog, 5 bytes

a⊇=bh

Try it online!

Explanation

a⊇=bh  Input is a list.
a      There is an adfix (prefix or suffix) of the input
 ⊇     and a subsequence of that adfix
  =    whose elements are all equal.
   b   Drop its first element
    h  and output the first element of the rest.

The adfix built-in a lists first all prefixes in increasing order of length, then suffixes in decreasing order of length. Thus the output is produced by the shortest prefix that allows it, if any. If a prefix has no duplicates, the rest of the program fails for it, since every subsequence of equal elements has length 1, and the first element of its tail doesn't exist. If a prefix has a repeated element, we can choose the length-2 subsequence containing both, and the program returns the latter.

\$\endgroup\$
1
  • \$\begingroup\$ Another 5 bytes solution: a⊇Ċ=h, which only looks at length-2 subsets. \$\endgroup\$
    – Fatalize
    Dec 1, 2017 at 7:20
3
+100
\$\begingroup\$

Python 3, 94 92 bytes

O(n) time and O(1) extra memory.

def f(a):
 r=-1
 for i in range(len(a)):t=abs(a[i])-1;r=[r,i+1][a[t]<0>r];a[t]*=-1
 return r

Try it online!

Source of the algorithm.

Explanation

The basic idea of the algorithm is to run through each element from left to right, keep track of the numbers that have appeared, and returning the number upon reaching a number that has already appeared, and return -1 after traversing each element.

However, it uses a clever way to store the numbers that have appeared without using extra memory: to store them as the sign of the element indexed by the number. For example, I can represent the fact that 2 and 3 has already appeared by having a[2] and a[3] negative, if the array is 1-indexed.

\$\endgroup\$
8
  • \$\begingroup\$ What would this do for i where a[i] > n? \$\endgroup\$
    – Downgoat
    Jul 31, 2017 at 6:02
  • \$\begingroup\$ @Downgoat read the question again. \$\endgroup\$
    – Leaky Nun
    Jul 31, 2017 at 6:04
  • \$\begingroup\$ The question says 1 to a.length but for a[i]= a.length wouldn't this go out of bounds? \$\endgroup\$
    – Downgoat
    Jul 31, 2017 at 6:05
  • \$\begingroup\$ @Downgoat t=abs(a[i])-1=a.length-1 \$\endgroup\$
    – Leaky Nun
    Jul 31, 2017 at 6:09
  • 3
    \$\begingroup\$ Note from feersum: "solution is cheating because it uses integers 1 bit larger than the input." \$\endgroup\$
    – Leaky Nun
    Jul 31, 2017 at 6:22
3
\$\begingroup\$

Perl 6, 13 bytes

*.repeated[0]

Try it


Explanation

  • The * is in a Term position so the whole statement is a WhateverCode lambda.

  • The .repeated is a method that results in every value except for the first time each value was seen.

    say [2, 3, 3, 3, 1, 5, 2, 3].repeated.perl; # (3, 3, 2, 3).Seq
    #   (      3, 3,       2, 3).Seq
    
  • [0] just returns the first value in the Seq.
    If there is no value Nil is returned.
    (Nil is the base of the Failure types, and all types are their own undefined value, so Nil different than an undefined value in most other languages)


Note that since the implementation of .repeated generates a Seq that means it doesn't start doing any work until you ask for a value, and it only does enough work to generate what you ask for.
So it would be easy to argue this has at worst O(n) time complexity, and at best O(2) time complexity if the second value is a repeat of the first.
Similar can probably be said of memory complexity.

\$\endgroup\$
3
\$\begingroup\$

J, 12 bytes

,&_1{~~:i.0:

Try it online!

Explanation

,&_1{~~:i.0:  Input: array M
      ~:      Nub-sieve
          0:  The constant 0
        i.    Find the index of the first occurrence of 0 (the first duplicate)
,&_1          Append -1 to M
    {~        Select the value from the previous at the index of the first duplicate
\$\endgroup\$
3
\$\begingroup\$

APL (Dyalog), 20 bytes

⊃n/⍨(,≢∪)¨,\n←⎕,2⍴¯1

Try it online!

2⍴¯1 negative one reshaped into a length-two list

⎕, get input (mnemonic: console box) and prepend to that

n← store that in n

,\ prefixes of n (lit. cumulative concatenation)

( apply the following tacit function to each prefix

, [is] the ravel (just ensures that the prefix is a list)

 different from

 the unique elements[?] (i.e. is does the prefix have duplicates?)

n/⍨ use that to filter n (removes all elements until the first for which a duplicate was found)

 pick the first element from that

\$\endgroup\$
3
  • \$\begingroup\$ Wow, you got beat three times. Still, +1. And can you add an explanation of how this works? \$\endgroup\$
    – Adalynn
    Aug 3, 2017 at 22:10
  • \$\begingroup\$ @Zacharý Apparently I just needed to get the ball rolling. Here you go. \$\endgroup\$
    – Adám
    Aug 4, 2017 at 5:13
  • \$\begingroup\$ @Zacharý Eventually, I managed to beat them all. \$\endgroup\$
    – Adám
    Aug 4, 2017 at 8:09
3
\$\begingroup\$

APL (Dyalog), 11 bytes

As per the new rules, throws an error if no duplicates exist.

⊢⊃⍨⍬⍴⍳∘≢~⍳⍨

Try it online!

⍳⍨ the indices of the first occurrence of each element

~ removed from

⍳∘≢ of all the indices

⍬⍴ reshape that into a scalar (gives zero if no data is available)

⊃⍨ use that to pick from (gives error on zero)

 the argument

\$\endgroup\$
2
  • \$\begingroup\$ Well, yeah, when the rules are changed, of course you can beat them all! \$\endgroup\$
    – Adalynn
    Aug 4, 2017 at 20:05
  • \$\begingroup\$ Well, I tied you. \$\endgroup\$
    – Adalynn
    Aug 4, 2017 at 20:56
3
\$\begingroup\$

APL, 15

{⊃⍵[(⍳⍴⍵)~⍵⍳⍵]}

Seems like we can return 0 instead of -1 when there are no duplicates, (thanks Adám for the comment). So 3 bytes less.

A bit of description:

⍵⍳⍵         search the argument in itself: returns for  each element the index of it's first occurrence
(⍳⍴⍵)~⍵⍳⍵   create a list of all indexes, remove those found in ⍵⍳⍵; i.e. remove all first elements
⊃⍵[...]     of all remaining elements, take the first. If the array is empty, APL returns zero

For reference, old solution added -1 to the list at the end, so if the list ended up empty, it would contain -1 instead and the first element would be -1.

{⊃⍵[(⍳⍴⍵)~⍵⍳⍵],¯1}

Try it on tryapl.org

\$\endgroup\$
1
3
\$\begingroup\$

Retina, 26 24 bytes

1!`\b(\d+)\b(?<=\b\1 .*)

Try it online! Explanation: \b(\d+)\b matches each number in turn, and then the lookbehind looks to see whether the number is a duplicate; if it is the 1st match is ! output, rather than the count of matches. Unfortunately putting the lookbehind first doesn't seem to work, otherwise it would save several bytes. Edit: Added 7 bytes to comply with the -1 return value on no match. Saved 2 bytes thanks to @MartinEnder.

\$\endgroup\$
4
  • 2
    \$\begingroup\$ For the record, the lookaround won't backtrack. This prevents this from working if you try to put it before. I've made this mistake many times, and Martin always corrects me. \$\endgroup\$ Jul 31, 2017 at 0:37
  • \$\begingroup\$ I got 30 bytes by using a lookahead instead of a lookbehind. Also, the rules now say you don't need to return -1. \$\endgroup\$
    – Value Ink
    Aug 4, 2017 at 7:45
  • \$\begingroup\$ @ValueInk But the correct answer for that test case is 3... \$\endgroup\$
    – Neil
    Aug 4, 2017 at 8:00
  • \$\begingroup\$ OH. I misread the challenge, whoops \$\endgroup\$
    – Value Ink
    Aug 4, 2017 at 8:47
3
\$\begingroup\$

PHP, 56 44 38 32 bytes

for(;!${$argv[++$x]}++;);echo$x;

Run like this:

php -nr 'for(;!${$argv[++$x]}++;);echo$x;' -- 2 3 3 1 5 2;echo
> 3

Explanation

for(
  ;
  !${                 // Loop until current value as a variable is truthy
    $argv[++$x]       // The item to check for is the next item from input
  }++;                // Post increment, the var is now truthy
);
echo $x;              // Echo the index of the duplicate.

Tweaks

  • Saved 12 bytes by using variables instead of an array
  • Saved 6 bytes by making use of the "undefined behavior" rule for when there is no match.
  • Saved 6 bytes by using post-increment instead of setting to 1 after each loop

Complexity

As can be seen from the commented version of the code, the time complexity is linear O(n). In terms of memory, a maximum of n+1 variables will be assigned. So that's O(n).

\$\endgroup\$
10
  • \$\begingroup\$ Thanks for not using a weird encoding. But you should add the error_reporting option to the byte count (or use -n, which is free). \$\endgroup\$
    – Titus
    Aug 11, 2017 at 11:33
  • \$\begingroup\$ We've been here before. PHP notices and warnings are ignorable. I might as well pipe them to /dev/null, which is the same. \$\endgroup\$
    – aross
    Aug 11, 2017 at 13:02
  • \$\begingroup\$ I tend to remember the wrong comments. :) Isn´t this O(n)? \$\endgroup\$
    – Titus
    Aug 11, 2017 at 13:04
  • \$\begingroup\$ Yes it's linear \$\endgroup\$
    – aross
    Aug 11, 2017 at 13:05
  • \$\begingroup\$ How is that O(1) for additional space? You're literally assigning a new variable per n, which is O(n) \$\endgroup\$
    – Xanderhall
    Aug 11, 2017 at 14:46
3
\$\begingroup\$

K (ngn/k), 11 bytes

*(~':?',\)#

Try it online!

*(~':?',\)#
 (       )#   keep the elements where the left function returns true
              (when applied to the whole array):
       ,\       prefixes
     ?'         uniquify each
  ~':           is it the same as previous?
*             first element
\$\endgroup\$
2
\$\begingroup\$

R, 34 bytes

c((x=scan())[duplicated(x)],-1)[1]

Cut a few characters off the answer from @djhurio, don't have enough reputation to comment though.

\$\endgroup\$
1
  • \$\begingroup\$ oh...I didn't see this answer; this is good for the prior spec when missing values required -1 but with the new spec, I managed to golf it down even more. This is still solid and it's a different approach from the way he did it, so I'll give you a +1! \$\endgroup\$
    – Giuseppe
    Jul 31, 2017 at 14:22
2
\$\begingroup\$

J, 17 16 bytes

(*/{_1,~i.&0)@~:

How?

(*/{_1,~i.&0)@~:

             @~: returns the nub sieve which is a vector with 1 for the first occurrence of an element in the argument and 0 otherwise

        i.&0     returns the first index of duplication

    _1,~         appends _1 to the index

 */              returns 0 with duplicates (product across nub sieve)

     {           select _1 if no duplicates, otherwise return the index
\$\endgroup\$
0
2
\$\begingroup\$

R, 28 bytes

(x=scan())[duplicated(x)][1]

Try it online!

\$\endgroup\$
1
  • \$\begingroup\$ I think you can now return NA for missing values since the spec has changed; so (x=scan())[duplicated(x)][1] is perfectly valid. \$\endgroup\$
    – Giuseppe
    Jul 31, 2017 at 12:53
2
\$\begingroup\$

Dyalog APL Classic, 18 chars

Only works in ⎕IO←0.

     w[⊃(⍳∘≢~⍳⍨)w←¯1,⎕]

Remove from the list of indices of the elements of the argument with a prepended "-1" the list indices of its nub and then pick the first of what's left. If after the removal there only remains an empty vector, its first element is by definition 0 which is used to index the extended argument producing the desired -1.

\$\endgroup\$
2
  • \$\begingroup\$ Um... what's with the random leading spaces? +1 for outgolfing me by one byte. \$\endgroup\$
    – Adalynn
    Aug 3, 2017 at 22:07
  • \$\begingroup\$ You may throw an error instead of returning ¯1, so you can remove ¯1, and use ⎕IO←1. \$\endgroup\$
    – Adám
    Aug 4, 2017 at 5:30
2
\$\begingroup\$

Ruby, 28 36 bytes

Misunderstood the challenge the first time. O(n) time, O(n) space.

->a{d={};a.find{|e|b=d[e];d[e]=1;b}}

Try it online!

\$\endgroup\$
2
\$\begingroup\$

Java (OpenJDK 8), 65 117 109 bytes

Previous 65 byte solution:

r->{for(int a,b=0,z,i=0;;b=a)if((a=b|1<<(z=r[i++]))==b)return z;}

New solution. 19 bytes are included for import java.math.*;

-8 bytes thanks to @Nevay

r->{int z,i=0;for(BigInteger c=BigInteger.ZERO;c.min(c=c.setBit(z=r[i++]))!=c;);return z;}

Try it online!

Edit

The algorithm in my original program was fine, but the static size of the datatype used meant that it broke fairly quickly once the size went above a certain threshold.

I have changed the datatype used in the calculation to increase the memory limit of the program to accommodate this (using BigInteger for arbitrary precision instead of int or long). However, this makes it debatable whether or not this counts as O(1) space complexity.

I will leave my explanation below intact, but I wish to add that I now believe it is impossible to achieve O(1) space complexity without making some assumptions.

Proof

Define N as an integer such that 2 <= N .

Let S be a list representing a series of random integers [x{1}, ..., x{N}], where x{i} has the constraint 1 <= x{i} <= N.

The time complexity (in Big-O notation) required to iterate through this list exactly once per element is O(n)

The challenge given is to find the first duplicated value in the list. More specifically, we are searching for the first value in S that is a duplicate of a previous item on the list.

Let p and q be the positions of two elements in the list such that p < q and x{p} == x{q}. Our challenge becomes finding the smallest q that satisfies those conditions.

The obvious approach to this problem is to iterate through S and check if our x{i} exists in another list T: If x{i} does not exist in T, we store it in T. If x{i} does exist in T, it is the first duplicate value and therefore the smallest q, and as such we return it. This space efficiency is O(n).

In order to achieve O(1) space complexity while maintaining O(n) time complexity, we have to store unique information about each object in the list in a finite amount of space. Because of this, the only way any algorithm could perform at O(1) space complexity is if: 1. N is given an upper bound corresponding to the memory required to store the maximum number of possible values for a particular finite datatype. 2. The re-assignment of a single immutable variable is not counted against the complexity, only the number of variables (a list being multiple variables). 3. (Based on other answers) The list is (or at least, the elements of the list are) mutable, and the datatype of the list is preset as a signed integer, allowing for changes to be made to elements further in the list without using additional memory.

1 and 3 both require assumptions and specifications about the datatype, while 2 requires that only the number of variables be considered for the calculation of space complexity, rather than the size of those variables. If none of these assumptions are accepted, it would be impossible to achieve both O(n) time complexity and O(1) space complexity.

Explanation

Whoo boy, this one took an embarrassingly long time to think up a bit of brain power.

So, going for the bonus is difficult. We need both to operate over the entire list exactly once and track which values we've already iterated over without additional space complexity.

Bit manipulation solves those problems. We initialize our O(1) 'storage', a pair of integers, then iterate through the list, OR-ing the ith bit in our first integer and storing that result to the second.

For instance, if we have 1101, and we perform an OR operation with 10, we get 1111. If we do another OR with 10, we still have 1101.

Ergo, once we perform the OR operation and end up with the same number, we've found our duplicate. No duplicates in the array causes the program to run over and throw an exception.

\$\endgroup\$
10
  • \$\begingroup\$ Also, your second test includes the number 100, but thats impossible since the array itself is only 5 long \$\endgroup\$
    – SchoolBoy
    Aug 10, 2017 at 14:54
  • \$\begingroup\$ Also, this fails since an int doesn't have enough storage. \$\endgroup\$
    – SchoolBoy
    Aug 10, 2017 at 14:59
  • \$\begingroup\$ @SchoolBoy Good catch. My only problem is that there doesn't seem to be any upper limit on the size of the array, so I can't realistically change my code to solve memory issues. \$\endgroup\$
    – Xanderhall
    Aug 10, 2017 at 16:26
  • \$\begingroup\$ @Xanderhall True, but i feel like 32 (or if you use a long, 64) numbers is too little :p. Either way, imposing a limit on the input, and then allocating the maximum memory needed and calling it O(1) memory is just a cheat. It is still O(n) since if the size of the input increased, so would this upper bound to the memory. Which is also why I think it is impossible to create an O(n) O(1) algorithm \$\endgroup\$
    – SchoolBoy
    Aug 10, 2017 at 16:29
  • \$\begingroup\$ @Xanderhall P.S. I'm getting close to your 65, I'm at 67 bytes :p \$\endgroup\$
    – SchoolBoy
    Aug 10, 2017 at 16:29
2
\$\begingroup\$

Java 8, 82 78 76 bytes No longer viable, 75 67 64 bytes below in edit

As a lambda function:

a->{Set<Long>s=new HashSet<>();for(long i:a)if(!s.add(i))return i;return-1;}

Probably can be made much smaller, this was very quick.

Explanation:

a->{                                //New lambda function with 'a' as input
    Set<Long>s=new HashSet<>();     //New set
    for(long i:a)                   //Iterate over a
        if(!s.add(i))               //If can't add to s, already exists
            return i;               //Return current value
        return-1;                   //No dupes, return -1
}

*Edit*

75 67 64 bytes using the negation strategy:

a->{int i=0,j;while((a[j=Math.abs(a[i++])-1]*=-1)<0);return++j;}

Try it online!

(-3 bytes thanks to @Nevay)

Explanation:

a->{                                         //New lambda expression with 'a' as input
    int i=0,j;                               //Initialise i and declare j
    while((a[j=Math.abs(a[i++])-1]*=-1)<0);  //Negate to keep track of current val until a negative is found
    return++j;                               //Return value
}

Loops over the array, negating to keep track. If no dupes, just runs over and throws an error.

Both of these work on O(n) time and O(n) space complexity.

\$\endgroup\$
4
  • \$\begingroup\$ It's worth noting that this will need to be assigned to a lambda returning Number, since i is a long and -1 is an int. \$\endgroup\$
    – Jakob
    Aug 10, 2017 at 14:36
  • \$\begingroup\$ @Jakob Not necessary, -1 being an int will automatically be cast to a long without explicitly specifying the cast \$\endgroup\$
    – SchoolBoy
    Aug 10, 2017 at 14:47
  • \$\begingroup\$ It will cast implicitly to long, but not to Long as required for the lambda to be assigned to a Function. Did you test it? Regardless, that solution can be replaced with your new one. \$\endgroup\$
    – Jakob
    Aug 10, 2017 at 16:13
  • 1
    \$\begingroup\$ You can use raw types Set s=new HashSet(); to save 7 bytes. (Besides: afaik the import of java.util.*; has to be included into the byte count -> +19 bytes.) The return statement can be return++j, the if-statement can be removed a->{int i=0,j;for(;(a[j=Math.abs(a[i++])-1]*=-1)<0;);return++j;} (-3 bytes). \$\endgroup\$
    – Nevay
    Aug 11, 2017 at 13:34
2
\$\begingroup\$

Husk, 4 bytes

←Ṡ-u

Returns 0 if no input contains no duplicate, try it online!

Explanation

←Ṡ-u  -- takes a list X as input & returns 0 or first duplicate
 Ṡ-   -- compute X - ...
   u  --       ...   deduplicate X
←     -- get first element or 0 if empty
\$\endgroup\$
2
\$\begingroup\$

Haskell, 34 bytes

import Data.List
f x=head$x\\nub x

Try it online! For an input x = [2,3,3,1,5,2], nub x removes duplicates [2,3,1,5] and x\\nub x removes the elements of nub x from x, thus keeping the duplicates [3,2]. head returns the first element of hat list.


Point-free is the same byte count: head.((\\)<*>nub).

\$\endgroup\$
2
\$\begingroup\$

MATL, 8 bytes

&=Rsqf1)

Gives an error (without output) if no duplicate exists.

Try at MATL Online!

Explanation

&=   % Implict input. Matrix of all pairwise equality comparisons
R    % Keep the upper triangular part (i.e. set lower part to false)
s    % Sum of each column
q    % Subtract 1
f    % Indices of nonzero values
1)   % Get first. Gives an error is there is none. Implictly display
\$\endgroup\$
0

Your Answer

By clicking “Post Your Answer”, you agree to our terms of service and acknowledge that you have read and understand our privacy policy and code of conduct.

Not the answer you're looking for? Browse other questions tagged or ask your own question.